/*
 * This is part of the ANL/MCS/FL CAVEav distribution.
 *     written by Ivan R. Judson
 *
 */

#include <CAVtv.h>

CAVtv::CAVtv(float x, float y, float z)
{
  _px = x; _py = y; _pz = z;
  _red = 0.1; _green = 0.1; _blue = 0.2; _alpha = 1.0;
  _frate = 1;

  _imagepool = new CAVImagePool(0, 0, 0, 10);

  //  glGenTexturesEXT(1, _texids);
}

CAVtv::~CAVtv(void)
{
  delete _imagepool;
}

void CAVtv::Init(void)
{
}

void CAVtv::Draw(void)
{
  static float normal[3] = {  0.0,  0.0, -1.0 };

  // This is a unit cube therefore its eight corners are:

  float flt[3] = { -0.5,  5.5, -0.5 };  //  flt = front left top
  float flb[3] = { -0.5,  4.5, -0.5 };  //  flb = front left bottom
  float frt[3] = {  0.5,  5.5, -0.5 };  //  frt = front right top
  float frb[3] = {  0.5,  4.5, -0.5 };  //  frb = front right bottom
  float blt[3] = { -0.5,  5.5, 0.5 };  //  blt = back left top
  float blb[3] = { -0.5,  4.5, 0.5 };  //  blb = back left bottom
  float brt[3] = {  0.5,  5.5, 0.5 };  //  brt = back right top
  float brb[3] = {  0.5,  4.5, 0.5 };  //  brb = back right bottom

  // Only so fast
  
  if(!(_fc % _frate)) 
    {
      // Load in the new frame
  
      GetPix();
  
      // Build the texture with the new frame

      Process();

      // Increment the frame count 

      _fc++;
    }

  // Draw the TV
  glPushMatrix();
  {
    glColor3f(_red, _green, _blue);
    glBegin(GL_QUADS);
    {
//       // top
//       glVertex3fv(flt);
//       glVertex3fv(frt);
//       glVertex3fv(brt);
//       glVertex3fv(blt);

//       // bottom
//       glVertex3fv(flb);
//       glVertex3fv(frb);
//       glVertex3fv(brb);
//       glVertex3fv(blb);

//       // back
//       glVertex3fv(blb);
//       glVertex3fv(brb);
//       glVertex3fv(brt);
//       glVertex3fv(blt);

//       // left
//       glVertex3fv(flb);
//       glVertex3fv(blb);
//       glVertex3fv(blt);
//       glVertex3fv(flt);

//       // right
//       glVertex3fv(frb);
//       glVertex3fv(brb);
//       glVertex3fv(brt);
//       glVertex3fv(frt);
      
      // front texture mapped
      glNormal3fv(normal);
      glTexCoord2f(0.0, 0.0);
      glVertex3fv(flb);

      glNormal3fv(normal);
      glTexCoord2f(_s_coord, 0.0);
      glVertex3fv(flt);

      glNormal3fv(normal);
      glTexCoord2f(_s_coord, _t_coord);
      glVertex3fv(frt);

      glNormal3fv(normal);
      glTexCoord2f(0.0, _t_coord);
      glVertex3fv(frb);
      
    }
    glEnd();
  }
  glPopMatrix();
}

void CAVtv::Process(void)
{

}

void CAVtv::GetPix(void)
{
  
}


